diff -dcrpN postgresql.orig/src/backend/commands/analyze.c postgresql/src/backend/commands/analyze.c
*** postgresql.orig/src/backend/commands/analyze.c	2011-09-12 09:54:31.169314275 +0200
--- postgresql/src/backend/commands/analyze.c	2011-09-13 11:15:14.977046160 +0200
***************
*** 20,31 ****
--- 20,34 ----
  #include "access/tupconvert.h"
  #include "access/tuptoaster.h"
  #include "access/xact.h"
+ #include "catalog/heap.h"
  #include "catalog/index.h"
  #include "catalog/indexing.h"
+ #include "catalog/namespace.h"
  #include "catalog/pg_collation.h"
  #include "catalog/pg_inherits_fn.h"
  #include "catalog/pg_namespace.h"
  #include "commands/dbcommands.h"
+ #include "commands/defrem.h"
  #include "commands/tablecmds.h"
  #include "commands/vacuum.h"
  #include "executor/executor.h"
***************
*** 41,47 ****
--- 44,52 ----
  #include "storage/procarray.h"
  #include "utils/acl.h"
  #include "utils/attoptcache.h"
+ #include "utils/builtins.h"
  #include "utils/datum.h"
+ #include "utils/fmgroids.h"
  #include "utils/guc.h"
  #include "utils/lsyscache.h"
  #include "utils/memutils.h"
*************** typedef struct AnlIndexData
*** 68,75 ****
  {
  	IndexInfo  *indexInfo;		/* BuildIndexInfo result */
  	double		tupleFract;		/* fraction of rows for partial index */
! 	VacAttrStats **vacattrstats;	/* index attrs to analyze */
! 	int			attr_cnt;
  } AnlIndexData;
  
  
--- 73,82 ----
  {
  	IndexInfo  *indexInfo;		/* BuildIndexInfo result */
  	double		tupleFract;		/* fraction of rows for partial index */
! 	VacStats **vacstats;		/* index attrs to analyze */
! 	int			stats_cnt;	/* this many stats we need to compute - single and cross-column stats included */
! 	int			attr_cnt;	/* the relation has attr_cnt number of columns */
! 	bool			has_xcol_stats;
  } AnlIndexData;
  
  
*************** static void compute_index_stats(Relation
*** 93,100 ****
  					AnlIndexData *indexdata, int nindexes,
  					HeapTuple *rows, int numrows,
  					MemoryContext col_context);
! static VacAttrStats *examine_attribute(Relation onerel, int attnum,
! 				  Node *index_expr);
  static int acquire_sample_rows(Relation onerel, HeapTuple *rows,
  					int targrows, double *totalrows, double *totaldeadrows);
  static double random_fract(void);
--- 100,107 ----
  					AnlIndexData *indexdata, int nindexes,
  					HeapTuple *rows, int numrows,
  					MemoryContext col_context);
! static VacStats *examine_attribute(Relation onerel, int2vector *attnums, bool inh,
! 				  Node **index_expr);
  static int acquire_sample_rows(Relation onerel, HeapTuple *rows,
  					int targrows, double *totalrows, double *totaldeadrows);
  static double random_fract(void);
*************** static int acquire_inherited_sample_rows
*** 105,116 ****
  							  HeapTuple *rows, int targrows,
  							  double *totalrows, double *totaldeadrows);
  static void update_attstats(Oid relid, bool inh,
! 				int natts, VacAttrStats **vacattrstats);
! static Datum std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
! static Datum ind_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
  
! static bool std_typanalyze(VacAttrStats *stats);
  
  
  /*
   *	analyze_rel() -- analyze one relation
--- 112,129 ----
  							  HeapTuple *rows, int targrows,
  							  double *totalrows, double *totaldeadrows);
  static void update_attstats(Oid relid, bool inh,
! 				int natts, VacStats **vacstats);
! static Datum std_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum,
! 							  bool *isNull);
! static Datum ind_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum,
! 							  bool *isNull);
  
! static bool std_typanalyze(VacStats *stats, int index);
  
+ static int ordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg);
+ static int unordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg);
+ static void compute_cross_column_stats(VacStatsP stats, AnalyzeAttrFetchFunc fetchfunc,
+ 							  int numrows);
  
  /*
   *	analyze_rel() -- analyze one relation
*************** analyze_rel(Oid relid, VacuumStmt *vacst
*** 253,272 ****
  	LWLockRelease(ProcArrayLock);
  }
  
  /*
   *	do_analyze_rel() -- analyze one relation, recursively or not
   */
  static void
  do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
  {
! 	int			attr_cnt,
  				tcnt,
  				i,
  				ind;
  	Relation   *Irel;
  	int			nindexes;
  	bool		hasindex;
! 	VacAttrStats **vacattrstats;
  	AnlIndexData *indexdata;
  	int			targrows,
  				numrows;
--- 266,343 ----
  	LWLockRelease(ProcArrayLock);
  }
  
+ static int
+ get_extrastats_count(Oid relid, int2vector ***out_attnumvectors)
+ {
+ 	Relation	pgstatistic;
+ 	TupleDesc	tupDesc;
+ 	SysScanDesc	scan;
+ 	ScanKeyData	key;
+ 	HeapTuple	tuple;
+ 	int		count = 0;
+ 	bool		isnull;
+ 	int2vector *attnumvector = NULL;
+ 	int2vector **attnumvectors = NULL;
+ 
+ 	pgstatistic = heap_open(StatisticRelationId, RowExclusiveLock);
+ 	tupDesc = RelationGetDescr(pgstatistic);
+ 
+ 	ScanKeyInit(&key,
+ 				Anum_pg_statistic_starelid,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(relid));
+ 
+ 	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumsInhIndexId, true,
+ 								SnapshotNow, 1, &key);
+ 
+ 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
+ 	{
+ 		Datum	attnvec = heap_getattr(tuple, Anum_pg_statistic_staattnums, tupDesc, &isnull);
+ 
+ 		Assert(!isnull);
+ 
+ 		attnumvector = (int2vector *) DatumGetPointer(attnvec);
+ 
+ 		if (attnumvector->dim1 > 1)
+ 		{
+ 			count++;
+ 			if (out_attnumvectors)
+ 			{
+ 				if (attnumvectors == NULL)
+ 					attnumvectors = palloc(count * sizeof(int2vector *));
+ 				else
+ 					attnumvectors = repalloc(attnumvectors, count * sizeof(int2vector *));
+ 				attnumvectors[count - 1] = (int2vector *)datumCopy(attnvec, false, -1);
+ 			}
+ 		}
+ 	}
+ 
+ 	systable_endscan(scan);
+ 	                                                                                                  
+ 	heap_close(pgstatistic, RowExclusiveLock);
+ 
+ 	if (out_attnumvectors)
+ 		*out_attnumvectors = attnumvectors;
+ 
+ 	return count;
+ }
+ 
  /*
   *	do_analyze_rel() -- analyze one relation, recursively or not
   */
  static void
  do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
  {
! 	int			stats_cnt,
! 				extrastats_cnt,
  				tcnt,
  				i,
  				ind;
  	Relation   *Irel;
  	int			nindexes;
  	bool		hasindex;
! 	VacStats **vacstats;
! 	int2vector   **extrastats_attnums;
  	AnlIndexData *indexdata;
  	int			targrows,
  				numrows;
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 329,366 ****
  	{
  		ListCell   *le;
  
! 		vacattrstats = (VacAttrStats **) palloc(list_length(vacstmt->va_cols) *
! 												sizeof(VacAttrStats *));
  		tcnt = 0;
  		foreach(le, vacstmt->va_cols)
  		{
  			char	   *col = strVal(lfirst(le));
  
! 			i = attnameAttNum(onerel, col, false);
! 			if (i == InvalidAttrNumber)
  				ereport(ERROR,
  						(errcode(ERRCODE_UNDEFINED_COLUMN),
  					errmsg("column \"%s\" of relation \"%s\" does not exist",
  						   col, RelationGetRelationName(onerel))));
! 			vacattrstats[tcnt] = examine_attribute(onerel, i, NULL);
! 			if (vacattrstats[tcnt] != NULL)
  				tcnt++;
  		}
! 		attr_cnt = tcnt;
  	}
  	else
  	{
! 		attr_cnt = onerel->rd_att->natts;
! 		vacattrstats = (VacAttrStats **)
! 			palloc(attr_cnt * sizeof(VacAttrStats *));
  		tcnt = 0;
! 		for (i = 1; i <= attr_cnt; i++)
  		{
! 			vacattrstats[tcnt] = examine_attribute(onerel, i, NULL);
! 			if (vacattrstats[tcnt] != NULL)
  				tcnt++;
  		}
! 		attr_cnt = tcnt;
  	}
  
  	/*
--- 400,474 ----
  	{
  		ListCell   *le;
  
! 		vacstats = (VacStats **) palloc(list_length(vacstmt->va_cols) *
! 												sizeof(VacStats *));
  		tcnt = 0;
  		foreach(le, vacstmt->va_cols)
  		{
  			char	   *col = strVal(lfirst(le));
+ 			AttrNumber attnum;
+ 			int2vector *attnums;
  
! 			attnum = attnameAttNum(onerel, col, false);
! 			if (attnum == InvalidAttrNumber)
  				ereport(ERROR,
  						(errcode(ERRCODE_UNDEFINED_COLUMN),
  					errmsg("column \"%s\" of relation \"%s\" does not exist",
  						   col, RelationGetRelationName(onerel))));
! 			attnums = buildint2vector(&attnum, 1);
! 			vacstats[tcnt] = examine_attribute(onerel, attnums, inh, NULL);
! 			if (vacstats[tcnt] != NULL)
  				tcnt++;
+ 			else
+ 				pfree(attnums);
  		}
! 		stats_cnt = tcnt;
! 		extrastats_cnt = 0;
  	}
  	else
  	{
! 		/*
! 		 * Process all attributes of the relation unconditionally
! 		 * as system tables may not have pg_statistic entries at
! 		 * this point, they will be created in update_attstats().
! 		 */
! 		stats_cnt = onerel->rd_att->natts;
! 
! 		extrastats_cnt = get_extrastats_count(onerel->rd_id, &extrastats_attnums);
! 
! 		vacstats = (VacStats **)
! 			palloc((stats_cnt + extrastats_cnt) * sizeof(VacStats *));
  		tcnt = 0;
! 		for (i = 1; i <= stats_cnt; i++)
  		{
! 			AttrNumber attnum = i;
! 			int2vector *attnums;
! 
! 			attnums = buildint2vector(&attnum, 1);
! 
! 			vacstats[tcnt] = examine_attribute(onerel, attnums, inh, NULL);
! 			if (vacstats[tcnt] != NULL)
  				tcnt++;
+ 			else
+ 				pfree(attnums);
  		}
! 
! 		/* Now process the extra statistics */
! 		if (extrastats_attnums)
! 		{
! 			for (i = 0; extrastats_attnums && i < extrastats_cnt; i++)
! 			{
! 				vacstats[tcnt] = examine_attribute(onerel, extrastats_attnums[i], inh, NULL);
! 				if (vacstats[tcnt] != NULL)
! 					tcnt++;
! 				else
! 					pfree(extrastats_attnums[i]);
! 			}
! 			pfree(extrastats_attnums);
! 			extrastats_attnums = NULL;
! 		}
! 
! 		stats_cnt = tcnt;
  	}
  
  	/*
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 389,401 ****
  
  			thisdata->indexInfo = indexInfo = BuildIndexInfo(Irel[ind]);
  			thisdata->tupleFract = 1.0; /* fix later if partial */
  			if (indexInfo->ii_Expressions != NIL && vacstmt->va_cols == NIL)
  			{
  				ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
  
! 				thisdata->vacattrstats = (VacAttrStats **)
! 					palloc(indexInfo->ii_NumIndexAttrs * sizeof(VacAttrStats *));
! 				tcnt = 0;
  				for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
  				{
  					int			keycol = indexInfo->ii_KeyAttrNumbers[i];
--- 497,516 ----
  
  			thisdata->indexInfo = indexInfo = BuildIndexInfo(Irel[ind]);
  			thisdata->tupleFract = 1.0; /* fix later if partial */
+ 
+ 			tcnt = 0;
+ 			extrastats_cnt = get_extrastats_count(Irel[ind]->rd_id, &extrastats_attnums);
+ 
+ 			/*
+ 			 * Process expression index single-attribute statistics.
+ 			 */
  			if (indexInfo->ii_Expressions != NIL && vacstmt->va_cols == NIL)
  			{
  				ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
  
! 				thisdata->vacstats = (VacStats **)
! 					palloc((indexInfo->ii_NumIndexAttrs + extrastats_cnt) * sizeof(VacStats *));
! 
  				for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
  				{
  					int			keycol = indexInfo->ii_KeyAttrNumbers[i];
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 404,422 ****
  					{
  						/* Found an index expression */
  						Node	   *indexkey;
  
  						if (indexpr_item == NULL)		/* shouldn't happen */
  							elog(ERROR, "too few entries in indexprs list");
  						indexkey = (Node *) lfirst(indexpr_item);
  						indexpr_item = lnext(indexpr_item);
! 						thisdata->vacattrstats[tcnt] =
! 							examine_attribute(Irel[ind], i + 1, indexkey);
! 						if (thisdata->vacattrstats[tcnt] != NULL)
  							tcnt++;
  					}
  				}
! 				thisdata->attr_cnt = tcnt;
  			}
  		}
  	}
  
--- 519,592 ----
  					{
  						/* Found an index expression */
  						Node	   *indexkey;
+ 						AttrNumber	attnum;
+ 						int2vector *attnums;
  
  						if (indexpr_item == NULL)		/* shouldn't happen */
  							elog(ERROR, "too few entries in indexprs list");
  						indexkey = (Node *) lfirst(indexpr_item);
  						indexpr_item = lnext(indexpr_item);
! 
! 						attnum = i + 1;
! 						attnums = buildint2vector(&attnum, 1);
! 
! 						thisdata->vacstats[tcnt] =
! 							examine_attribute(Irel[ind], attnums, inh, &indexkey);
! 						if (thisdata->vacstats[tcnt] != NULL)
  							tcnt++;
+ 						else
+ 							pfree(attnums);
  					}
  				}
! 
  			}
+ 
+ 			/*
+ 			 * Process cross-column statistics. There can only be at most one
+ 			 * multi-column statistics for an index that covers every attributes.
+ 			 */
+ 			if (extrastats_attnums && vacstmt->va_cols == NIL)
+ 			{
+ 				Node	   *indexkeys[STATISTIC_NUM_SLOTS];
+ 
+ 				if (thisdata->vacstats == NULL)
+ 					thisdata->vacstats = (VacStats **) palloc(sizeof(VacStats *));
+ 
+ 				/*
+ 				 * Don't process indexes with too many attributes.
+ 				 * CREATE EXTRA STATISTICS bails out for such a case
+ 				 * but better safe than sorry.
+ 				 */
+ 				if (indexInfo->ii_NumIndexAttrs <= STATISTIC_NUM_SLOTS)
+ 				{
+ 					ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
+ 
+ 					for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
+ 					{
+ 						int	keycol = indexInfo->ii_KeyAttrNumbers[i];
+ 						if (keycol == 0)
+ 						{
+ 							indexkeys[i] = (Node *) lfirst(indexpr_item);
+ 							indexpr_item = lnext(indexpr_item);
+ 						}
+ 						else
+ 							indexkeys[i] = NULL;
+ 					}
+ 
+ 					thisdata->vacstats[tcnt] = examine_attribute(onerel, extrastats_attnums[0], inh, indexkeys);
+ 					if (thisdata->vacstats[tcnt] != NULL)
+ 						tcnt++;
+ 					else
+ 						pfree(extrastats_attnums[i]);
+ 				}
+ 				pfree(extrastats_attnums);
+ 				extrastats_attnums = NULL;
+ 
+ 				thisdata->has_xcol_stats = true;
+ 			}
+ 
+ 			thisdata->stats_cnt = tcnt;
+ 			thisdata->attr_cnt = indexInfo->ii_NumIndexAttrs;
  		}
  	}
  
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 427,445 ****
  	 * the target in the corner case where there are no analyzable columns.)
  	 */
  	targrows = 100;
! 	for (i = 0; i < attr_cnt; i++)
  	{
! 		if (targrows < vacattrstats[i]->minrows)
! 			targrows = vacattrstats[i]->minrows;
  	}
  	for (ind = 0; ind < nindexes; ind++)
  	{
  		AnlIndexData *thisdata = &indexdata[ind];
  
! 		for (i = 0; i < thisdata->attr_cnt; i++)
  		{
! 			if (targrows < thisdata->vacattrstats[i]->minrows)
! 				targrows = thisdata->vacattrstats[i]->minrows;
  		}
  	}
  
--- 597,615 ----
  	 * the target in the corner case where there are no analyzable columns.)
  	 */
  	targrows = 100;
! 	for (i = 0; i < stats_cnt; i++)
  	{
! 		if (targrows < vacstats[i]->minrows)
! 			targrows = vacstats[i]->minrows;
  	}
  	for (ind = 0; ind < nindexes; ind++)
  	{
  		AnlIndexData *thisdata = &indexdata[ind];
  
! 		for (i = 0; i < thisdata->stats_cnt; i++)
  		{
! 			if (targrows < thisdata->vacstats[i]->minrows)
! 				targrows = thisdata->vacstats[i]->minrows;
  		}
  	}
  
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 457,463 ****
  	/*
  	 * Compute the statistics.	Temporary results during the calculations for
  	 * each column are stored in a child context.  The calc routines are
! 	 * responsible to make sure that whatever they store into the VacAttrStats
  	 * structure is allocated in anl_context.
  	 */
  	if (numrows > 0)
--- 627,633 ----
  	/*
  	 * Compute the statistics.	Temporary results during the calculations for
  	 * each column are stored in a child context.  The calc routines are
! 	 * responsible to make sure that whatever they store into the VacStats
  	 * structure is allocated in anl_context.
  	 */
  	if (numrows > 0)
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 472,504 ****
  											ALLOCSET_DEFAULT_MAXSIZE);
  		old_context = MemoryContextSwitchTo(col_context);
  
! 		for (i = 0; i < attr_cnt; i++)
  		{
! 			VacAttrStats *stats = vacattrstats[i];
! 			AttributeOpts *aopt =
! 			get_attribute_options(onerel->rd_id, stats->attr->attnum);
  
  			stats->rows = rows;
  			stats->tupDesc = onerel->rd_att;
! 			(*stats->compute_stats) (stats,
  									 std_fetch_func,
  									 numrows,
  									 totalrows);
  
! 			/*
! 			 * If the appropriate flavor of the n_distinct option is
! 			 * specified, override with the corresponding value.
! 			 */
! 			if (aopt != NULL)
! 			{
! 				float8		n_distinct =
! 				inh ? aopt->n_distinct_inherited : aopt->n_distinct;
  
! 				if (n_distinct != 0.0)
! 					stats->stadistinct = n_distinct;
  			}
  
  			MemoryContextResetAndDeleteChildren(col_context);
  		}
  
  		if (hasindex)
--- 642,683 ----
  											ALLOCSET_DEFAULT_MAXSIZE);
  		old_context = MemoryContextSwitchTo(col_context);
  
! 		for (i = 0; i < stats_cnt; i++)
  		{
! 			VacStats *stats = vacstats[i];
! 			AttributeOpts *aopt;
! 			int		j;
  
  			stats->rows = rows;
  			stats->tupDesc = onerel->rd_att;
! 
! 			for (j = 0; j < stats->attnums->dim1; j++)
! 			{
! 				aopt = get_attribute_options(onerel->rd_id, stats->attnums->values[j]);
! 
! 				(*stats->statfuncs[j].compute_func_ptr) (stats,
! 									 j, 
  									 std_fetch_func,
  									 numrows,
  									 totalrows);
  
! 				/*
! 				 * If the appropriate flavor of the n_distinct option is
! 				 * specified, override with the corresponding value.
! 				 */
! 				if (aopt != NULL)
! 				{
! 					float8		n_distinct =
! 					inh ? aopt->n_distinct_inherited : aopt->n_distinct;
  
! 					if (n_distinct != 0.0)
! 						stats->stadistinct[j] = n_distinct;
! 				}
  			}
  
  			MemoryContextResetAndDeleteChildren(col_context);
+ 
+ 			compute_cross_column_stats(stats, std_fetch_func, numrows);
  		}
  
  		if (hasindex)
*************** do_analyze_rel(Relation onerel, VacuumSt
*** 516,529 ****
  		 * pg_statistic for columns we didn't process, we leave them alone.)
  		 */
  		update_attstats(RelationGetRelid(onerel), inh,
! 						attr_cnt, vacattrstats);
  
  		for (ind = 0; ind < nindexes; ind++)
  		{
  			AnlIndexData *thisdata = &indexdata[ind];
  
  			update_attstats(RelationGetRelid(Irel[ind]), false,
! 							thisdata->attr_cnt, thisdata->vacattrstats);
  		}
  	}
  
--- 695,711 ----
  		 * pg_statistic for columns we didn't process, we leave them alone.)
  		 */
  		update_attstats(RelationGetRelid(onerel), inh,
! 						stats_cnt, vacstats);
  
  		for (ind = 0; ind < nindexes; ind++)
  		{
  			AnlIndexData *thisdata = &indexdata[ind];
  
+ 			for (i = 0; i < thisdata->stats_cnt; i++)
+ 				compute_cross_column_stats(thisdata->vacstats[i], ind_fetch_func, numrows);
+ 
  			update_attstats(RelationGetRelid(Irel[ind]), false,
! 							thisdata->stats_cnt, thisdata->vacstats);
  		}
  	}
  
*************** compute_index_stats(Relation onerel, dou
*** 627,632 ****
--- 809,816 ----
  				old_context;
  	Datum		values[INDEX_MAX_KEYS];
  	bool		isnull[INDEX_MAX_KEYS];
+ 	bool		typbyval[INDEX_MAX_KEYS];
+ 	int16		typlen[INDEX_MAX_KEYS];
  	int			ind,
  				i;
  
*************** compute_index_stats(Relation onerel, dou
*** 641,647 ****
  	{
  		AnlIndexData *thisdata = &indexdata[ind];
  		IndexInfo  *indexInfo = thisdata->indexInfo;
! 		int			attr_cnt = thisdata->attr_cnt;
  		TupleTableSlot *slot;
  		EState	   *estate;
  		ExprContext *econtext;
--- 825,831 ----
  	{
  		AnlIndexData *thisdata = &indexdata[ind];
  		IndexInfo  *indexInfo = thisdata->indexInfo;
! 		int			stats_cnt = thisdata->stats_cnt;
  		TupleTableSlot *slot;
  		EState	   *estate;
  		ExprContext *econtext;
*************** compute_index_stats(Relation onerel, dou
*** 652,662 ****
  					tcnt,
  					rowno;
  		double		totalindexrows;
  
  		/* Ignore index if no columns to analyze and not partial */
! 		if (attr_cnt == 0 && indexInfo->ii_Predicate == NIL)
  			continue;
  
  		/*
  		 * Need an EState for evaluation of index expressions and
  		 * partial-index predicates.  Create it in the per-index context to be
--- 836,865 ----
  					tcnt,
  					rowno;
  		double		totalindexrows;
+ 		ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
  
  		/* Ignore index if no columns to analyze and not partial */
! 		if (stats_cnt == 0 && indexInfo->ii_Predicate == NIL)
  			continue;
  
+ 		for (i = 0; i < thisdata->attr_cnt; i++)
+ 		{
+ 			int	keycol = indexInfo->ii_KeyAttrNumbers[i];
+ 
+ 			if (keycol == 0)
+ 			{
+ 				Node *indexkey = (Node *) lfirst(indexpr_item);
+ 
+ 				get_typlenbyval(exprType(indexkey), &typlen[i], &typbyval[i]);
+ 				indexpr_item = lnext(indexpr_item);
+ 			}
+ 			else
+ 			{
+ 				typbyval[i] = onerel->rd_att->attrs[keycol - 1]->attbyval;
+ 				typlen[i] = onerel->rd_att->attrs[keycol - 1]->attlen;
+ 			}
+ 		}
+ 
  		/*
  		 * Need an EState for evaluation of index expressions and
  		 * partial-index predicates.  Create it in the per-index context to be
*************** compute_index_stats(Relation onerel, dou
*** 676,683 ****
  							estate);
  
  		/* Compute and save index expression values */
! 		exprvals = (Datum *) palloc(numrows * attr_cnt * sizeof(Datum));
! 		exprnulls = (bool *) palloc(numrows * attr_cnt * sizeof(bool));
  		numindexrows = 0;
  		tcnt = 0;
  		for (rowno = 0; rowno < numrows; rowno++)
--- 879,886 ----
  							estate);
  
  		/* Compute and save index expression values */
! 		exprvals = (Datum *) palloc(numrows * thisdata->attr_cnt * sizeof(Datum));
! 		exprnulls = (bool *) palloc(numrows * thisdata->attr_cnt * sizeof(bool));
  		numindexrows = 0;
  		tcnt = 0;
  		for (rowno = 0; rowno < numrows; rowno++)
*************** compute_index_stats(Relation onerel, dou
*** 701,707 ****
  			}
  			numindexrows++;
  
! 			if (attr_cnt > 0)
  			{
  				/*
  				 * Evaluate the index row to compute expression values. We
--- 904,910 ----
  			}
  			numindexrows++;
  
! 			if (stats_cnt > 0)
  			{
  				/*
  				 * Evaluate the index row to compute expression values. We
*************** compute_index_stats(Relation onerel, dou
*** 714,737 ****
  							   isnull);
  
  				/*
! 				 * Save just the columns we care about.  We copy the values
! 				 * into ind_context from the estate's per-tuple context.
  				 */
! 				for (i = 0; i < attr_cnt; i++)
  				{
! 					VacAttrStats *stats = thisdata->vacattrstats[i];
! 					int			attnum = stats->attr->attnum;
! 
! 					if (isnull[attnum - 1])
  					{
  						exprvals[tcnt] = (Datum) 0;
  						exprnulls[tcnt] = true;
  					}
  					else
  					{
! 						exprvals[tcnt] = datumCopy(values[attnum - 1],
! 												   stats->attrtype->typbyval,
! 												   stats->attrtype->typlen);
  						exprnulls[tcnt] = false;
  					}
  					tcnt++;
--- 917,934 ----
  							   isnull);
  
  				/*
! 				 * We copy the values * into ind_context from the estate's per-tuple context.
  				 */
! 				for (i = 0; i < thisdata->attr_cnt; i++)
  				{
! 					if (isnull[i])
  					{
  						exprvals[tcnt] = (Datum) 0;
  						exprnulls[tcnt] = true;
  					}
  					else
  					{
! 						exprvals[tcnt] = datumCopy(values[i], typbyval[i], typlen[i]);
  						exprnulls[tcnt] = false;
  					}
  					tcnt++;
*************** compute_index_stats(Relation onerel, dou
*** 752,779 ****
  		if (numindexrows > 0)
  		{
  			MemoryContextSwitchTo(col_context);
! 			for (i = 0; i < attr_cnt; i++)
  			{
! 				VacAttrStats *stats = thisdata->vacattrstats[i];
! 				AttributeOpts *aopt =
! 				get_attribute_options(stats->attr->attrelid,
! 									  stats->attr->attnum);
  
! 				stats->exprvals = exprvals + i;
! 				stats->exprnulls = exprnulls + i;
! 				stats->rowstride = attr_cnt;
! 				(*stats->compute_stats) (stats,
! 										 ind_fetch_func,
! 										 numindexrows,
! 										 totalindexrows);
  
! 				/*
! 				 * If the n_distinct option is specified, it overrides the
! 				 * above computation.  For indices, we always use just
! 				 * n_distinct, not n_distinct_inherited.
! 				 */
! 				if (aopt != NULL && aopt->n_distinct != 0.0)
! 					stats->stadistinct = aopt->n_distinct;
  
  				MemoryContextResetAndDeleteChildren(col_context);
  			}
--- 949,985 ----
  		if (numindexrows > 0)
  		{
  			MemoryContextSwitchTo(col_context);
! 			for (i = 0; i < stats_cnt; i++)
  			{
! 				VacStats *stats = thisdata->vacstats[i];
! 				AttributeOpts *aopt;
! 				int		j;
  
! 				for (j = 0; j < stats->attnums->dim1; j++)
! 				{
! 					if (stats->attnums->dim1 == 1)
! 						aopt = get_attribute_options(stats->attrs[j]->attrelid,
! 										  stats->attrs[j]->attnum);
! 					else
! 						aopt = NULL;
  
! 					stats->exprvals = exprvals;
! 					stats->exprnulls = exprnulls;
! 					stats->rowstride = thisdata->attr_cnt;
! 					(*stats->statfuncs[j].compute_func_ptr) (stats,
! 											 j,
! 											 ind_fetch_func,
! 											 numindexrows,
! 											 totalindexrows);
! 
! 					/*
! 					 * If the n_distinct option is specified, it overrides the
! 					 * above computation.  For indices, we always use just
! 					 * n_distinct, not n_distinct_inherited.
! 					 */
! 					if (aopt != NULL && aopt->n_distinct != 0.0)
! 						stats->stadistinct[j] = aopt->n_distinct;
! 				}
  
  				MemoryContextResetAndDeleteChildren(col_context);
  			}
*************** compute_index_stats(Relation onerel, dou
*** 792,829 ****
  }
  
  /*
!  * examine_attribute -- pre-analysis of a single column
   *
   * Determine whether the column is analyzable; if so, create and initialize
!  * a VacAttrStats struct for it.  If not, return NULL.
   *
   * If index_expr isn't NULL, then we're trying to analyze an expression index,
   * and index_expr is the expression tree representing the column's data.
   */
! static VacAttrStats *
! examine_attribute(Relation onerel, int attnum, Node *index_expr)
  {
- 	Form_pg_attribute attr = onerel->rd_att->attrs[attnum - 1];
  	HeapTuple	typtuple;
! 	VacAttrStats *stats;
! 	int			i;
  	bool		ok;
  
! 	/* Never analyze dropped columns */
! 	if (attr->attisdropped)
! 		return NULL;
  
  	/* Don't analyze column if user has specified not to */
! 	if (attr->attstattarget == 0)
  		return NULL;
  
  	/*
! 	 * Create the VacAttrStats struct.	Note that we only have a copy of the
  	 * fixed fields of the pg_attribute tuple.
  	 */
! 	stats = (VacAttrStats *) palloc0(sizeof(VacAttrStats));
! 	stats->attr = (Form_pg_attribute) palloc(ATTRIBUTE_FIXED_PART_SIZE);
! 	memcpy(stats->attr, attr, ATTRIBUTE_FIXED_PART_SIZE);
  
  	/*
  	 * When analyzing an expression index, believe the expression tree's type
--- 998,1074 ----
  }
  
  /*
!  * statistics_target -- returns pg_statistic.statarget
!  */
! static int4
! statistics_target(Oid relid, int2vector *attnums, bool inherited)
! {
! 	HeapTuple		tuple;
! 	int4			statarget = -1; /* default */
! 
! 	tuple = SearchSysCache3(STATRELATTINH,
! 								ObjectIdGetDatum(relid),
! 								PointerGetDatum(attnums),
! 								BoolGetDatum(inherited));
! 	if (HeapTupleIsValid(tuple))
! 	{
! 		Form_pg_statistic stats = (Form_pg_statistic) GETSTRUCT(tuple);
! 
! 		statarget = stats->statarget;
! 
! 		ReleaseSysCache(tuple);
! 	}
! 
! 	return statarget;
! }
! 
! 
! /*
!  * examine_attribute -- pre-analysis of a single column or a set of columns
   *
   * Determine whether the column is analyzable; if so, create and initialize
!  * a VacStats struct for it.  If not, return NULL.
   *
   * If index_expr isn't NULL, then we're trying to analyze an expression index,
   * and index_expr is the expression tree representing the column's data.
   */
! static VacStats *
! examine_attribute(Relation onerel, int2vector *attnums, bool inh, Node **index_exprs)
  {
  	HeapTuple	typtuple;
! 	int4		statarget;
! 	VacStats *stats;
! 	int			i, j;
  	bool		ok;
  
! 	for (i = 0; i < attnums->dim1; i++)
! 	{
! 		Form_pg_attribute attr = onerel->rd_att->attrs[attnums->values[i] - 1];
! 
! 		/* Never analyze dropped columns */
! 		if (attr->attisdropped)
! 			return NULL;
! 	}
  
  	/* Don't analyze column if user has specified not to */
! 	statarget = statistics_target(onerel->rd_id, attnums, inh);
! 	if (statarget == 0)
  		return NULL;
  
  	/*
! 	 * Create the VacStats struct.	Note that we only have a copy of the
  	 * fixed fields of the pg_attribute tuple.
  	 */
! 	stats = (VacStats *) palloc0(sizeof(VacStats));
! 	for (i = 0; i < attnums->dim1; i++)
! 	{
! 		Form_pg_attribute attr = onerel->rd_att->attrs[attnums->values[i] - 1];
! 		stats->attrs[i] = (Form_pg_attribute) palloc(ATTRIBUTE_FIXED_PART_SIZE);
! 		memcpy(stats->attrs[i], attr, ATTRIBUTE_FIXED_PART_SIZE);
! 	}
! 
! 	stats->attnums = attnums;
! 	stats->statarget = statarget;
  
  	/*
  	 * When analyzing an expression index, believe the expression tree's type
